#include<stdio.h>
#include<math.h>
#include<complex.h>

int main(){

  double a,b,c,disc,x1,x2;

  double _Complex x1c, x2c;

  /* 標準入力からa,b,cを読み込む */
  printf("Solution of the quadratic equation a*x^2 + b*x + c = 0\n");
  printf("Enter a, b, c\n");
  scanf("%lf %lf %lf", &a, &b, &c);

  
  if ( fabs(a) < 1.0e-15) { // aがゼロの場合

    if (fabs(b) < 1.0e-15) { // bがゼロの場合

      if (fabs(c) < 1.0e-15) // cがゼロの場合
	/* a=b=c=0の場合は解は不定 */
	printf("any x can be a solution.\n");      
      else
	/* a=b=0でcがゼロでなければ解は存在しない */
	printf("Solutions do not exist\n");

    } else { // bがゼロでない場合、bx+c=0の1次方程式
      
      x1 = - c/b;
      printf("x =  %lf\n", x1);
      printf("ax^2+bx+c = %f\n", a*x1*x1+b*x1+c); // 解がもとの方程式を満たすかチェック 

    }

  } else { // aがゼロではない場合

    /* 判別式 */
    disc = b*b - 4.0*a*c;

    if(disc > 0.0){ // 判別式が正の場合
      /* 実数解が２つ */
      x1 = (-b + sqrt(disc))/(2.0*a);
      x2 = (-b - sqrt(disc))/(2.0*a);

      /* 解を出力 */
      printf("x1 = %f, x2 = %f\n", x1, x2);

      /* 解がもとの方程式をみたすかチェック */
      printf("ax^2+bx+c = %f\n", a*x1*x1+b*x1+c);
      printf("ax^2+bx+c = %f\n", a*x2*x2+b*x2+c);

    } else { // 判別式が負の場合

      /* 複素数解が２つ */
      x1c = (-b + sqrt(-disc)*I)/(2.0*a);
      x2c = (-b - sqrt(-disc)*I)/(2.0*a);
           
      printf("x1 = %+f %+f i,  x2 = %+f %+f i\n", creal(x1c), cimag(x1c), creal(x2c),cimag(x2c));

      /* 解がもとの方程式を満たすかチェック */
      printf("ax^2+bx+c = %+f  %+f i\n", creal(a*x1c*x1c+b*x1c+c), cimag(a*x1c*x1c+b*x1c+c));
      printf("ax^2+bx+c = %+f  %+f i\n", creal(a*x2c*x2c+b*x2c+c), cimag(a*x2c*x2c+b*x2c+c));

    }

  }
      
  return 0;
  
}
